
uint16_t createPlaylistFile(void)
// create a play list file on the SD card with the names of the files.
// This will then be used in the menu.
{
  SdFile    plFile;   // play list file
  SdFile    mFile;    // MIDI file
  
  uint16_t  count = 0;// count of files
  char      fname[FNAME_SIZE];
  
  if (!plFile.open(PLAYLIST_FILE, O_CREAT | O_WRITE))
  {
    showmsgXY(20, 60, 2, NULL, "PL create fail", RED);
  }
  else
  {
    while (mFile.openNext(&file, O_READ))
    {
      mFile.getName(fname, FNAME_SIZE);

      if (mFile.isFile())
      {
        if (strcasecmp(MIDI_EXT, &fname[strlen(fname) - strlen(MIDI_EXT)]) == 0)
          // only include files with MIDI extension
        {
          plFile.write(fname, FNAME_SIZE);
          
          count++;
        }
      }
      
      mFile.close();
    }
    
    plFile.close();
   }

  return (count);
}
