
seq_state midiFSM(seq_state curSS)
// Handle playing the selected MIDI file
{
  
  
  bool value;
  static int tempoAdjust = 0;
  static int oldvalue1 = HIGH, oldvalue2 = HIGH;
  static midi_state s = MSBegin;
  
  switch (s)
  {
  case MSBegin:
    
    s = MSLoad;
    break;

  case MSLoad:
// Load the current file in preparation for playing
    {
      int err;

      // Attempt to load the file
      if ((err = SMF.load(fname)) == MD_MIDIFile::E_OK)
      
        s = MSProcess;
      else
      {
        char aErr[16];

        sprintf(aErr, "SMF error %03d", err);
        
        showmsgXY(75, 130, 3, NULL, aErr, RED);
        s = MSClose;
        delay(2000);//Anzeigezeit SMF error
        resetFunc();//Neustart
      }
    }
    break;

  case MSProcess:
 
    if (!SMF.isEOF())
    {
       if (SMF.getNextEvent())
      {
       tickMetronome();//Blink Beat
       
      }
    }
    else
      s = MSClose;

    
    if (lbl = '0')
    
    {
      read_button();
            
      
      switch (lbl)
      {
      case '1': midiSilence();    SMF.restart(); SMF.setTempoAdjust(0);  callStatus3();        break;  // Back
      case '2': s = MSClose;      showmsgXY(15, 58, 2, NULL, "Stop ", GREEN);                  break;  // Stop
      case '4': SMF.pause(true);  midiSilence(); showmsgXY(15, 58, 2, NULL, "Pause", GREEN);   break;  // Pause
      case '3': SMF.pause(false); showmsgXY(15, 58, 2, NULL, "Play ", GREEN); 
                tempoAdjust = 0; SMF.setTempoAdjust(0);  callStatus3();                        break;  // Start, reset TempoAdjust
      case '6': SMF.setTempoAdjust(tempoAdjust+=5);  callStatus3();                            break;  // Tempo erhöhen
      case '7': SMF.setTempoAdjust(tempoAdjust-=5);  callStatus3();                            break;  // Tempo verringern
      }

    }
    
    break;


  case MSClose:
    // close the file and switch mode to user input
    SMF.close();
    midiSilence();
    showmsgXY(15, 58, 2, NULL, "Stop ", GREEN);
    curSS = TFTSeq;
    // fall through to default state
 
  default:
    s = MSBegin;
    break;

   
  }

  return(curSS);
}
